## nestopia 1.46.2

=== Makefile ===
CC = cc
CXX = c++
CXXFLAGS ?= -O3 -g3
CPPFLAGS += -DNST_PRAGMA_ONCE
CFLAGS = $(shell sdl2-config --cflags)

INCLUDES = -Isource
WARNINGS = -Wno-write-strings

LDFLAGS = -Wl,--as-needed
LIBS = -lstdc++ -lm -lz
LIBS += $(shell sdl2-config --libs)

UNAME := $(shell uname)

BIN = nestopia

PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
DATADIR = $(PREFIX)/share/nestopia

ifneq ($(findstring MINGW,$(UNAME)),)
	CPPFLAGS += -DNST_NO_ZLIB
	DEFINES = -D_MINGW
	LDFLAGS += -mconsole
	LIBS += -lopengl32
else
	DEFINES = -DDATADIR=\"$(DATADIR)\"
	LIBS += -larchive
	LIBS += -lGL -lGLU -lao
	# GTK Stuff - Comment this section to disable GTK+
	CFLAGS += $(shell pkg-config --cflags gtk+-3.0)
	LIBS += $(shell pkg-config --libs gtk+-3.0)
	DEFINES += -D_GTK
	IOBJS += objs/unix/gtkui/gtkui.o
	IOBJS += objs/unix/gtkui/gtkui_archive.o
	IOBJS += objs/unix/gtkui/gtkui_callbacks.o
	IOBJS += objs/unix/gtkui/gtkui_cheats.o
	IOBJS += objs/unix/gtkui/gtkui_config.o
	IOBJS += objs/unix/gtkui/gtkui_dialogs.o
	OBJDIRS += objs/unix/gtkui
	WARNINGS += -Wno-deprecated-declarations
	# end GTK
endif

# Core
OBJS += objs/core/NstApu.o
OBJS += objs/core/NstAssert.o
OBJS += objs/core/NstCartridge.o
OBJS += objs/core/NstCartridgeInes.o
OBJS += objs/core/NstCartridgeRomset.o
OBJS += objs/core/NstCartridgeUnif.o
OBJS += objs/core/NstCheats.o
OBJS += objs/core/NstChecksum.o
OBJS += objs/core/NstChips.o
OBJS += objs/core/NstCore.o
OBJS += objs/core/NstCpu.o
OBJS += objs/core/NstCrc32.o
OBJS += objs/core/NstFds.o
OBJS += objs/core/NstFile.o
OBJS += objs/core/NstImage.o
OBJS += objs/core/NstImageDatabase.o
OBJS += objs/core/NstLog.o
OBJS += objs/core/NstMachine.o
OBJS += objs/core/NstMemory.o
OBJS += objs/core/NstNsf.o
OBJS += objs/core/NstPatcher.o
OBJS += objs/core/NstPatcherIps.o
OBJS += objs/core/NstPatcherUps.o
OBJS += objs/core/NstPins.o
OBJS += objs/core/NstPpu.o
OBJS += objs/core/NstProperties.o
OBJS += objs/core/NstRam.o
OBJS += objs/core/NstSha1.o
OBJS += objs/core/NstSoundPcm.o
OBJS += objs/core/NstSoundPlayer.o
OBJS += objs/core/NstSoundRenderer.o
OBJS += objs/core/NstState.o
OBJS += objs/core/NstStream.o
OBJS += objs/core/NstTracker.o
OBJS += objs/core/NstTrackerMovie.o
OBJS += objs/core/NstTrackerRewinder.o
OBJS += objs/core/NstVector.o
OBJS += objs/core/NstVideoFilter2xSaI.o
OBJS += objs/core/NstVideoFilterHqX.o
OBJS += objs/core/NstVideoFilterNone.o
OBJS += objs/core/NstVideoFilterNtsc.o
OBJS += objs/core/NstVideoFilterNtscCfg.o
OBJS += objs/core/NstVideoFilterScaleX.o
OBJS += objs/core/NstVideoFilterxBR.o
OBJS += objs/core/NstVideoRenderer.o
OBJS += objs/core/NstVideoScreen.o
OBJS += objs/core/NstXml.o
OBJS += objs/core/NstZlib.o

# API
OBJS += objs/core/api/NstApiBarcodeReader.o
OBJS += objs/core/api/NstApiCartridge.o
OBJS += objs/core/api/NstApiCheats.o
OBJS += objs/core/api/NstApiDipSwitches.o
OBJS += objs/core/api/NstApiEmulator.o
OBJS += objs/core/api/NstApiFds.o
OBJS += objs/core/api/NstApiInput.o
OBJS += objs/core/api/NstApiMachine.o
OBJS += objs/core/api/NstApiMovie.o
OBJS += objs/core/api/NstApiNsf.o
OBJS += objs/core/api/NstApiRewinder.o
OBJS += objs/core/api/NstApiSound.o
OBJS += objs/core/api/NstApiTapeRecorder.o
OBJS += objs/core/api/NstApiUser.o
OBJS += objs/core/api/NstApiVideo.o

# Board
OBJS += objs/core/board/NstBoardAe.o
OBJS += objs/core/board/NstBoardAgci.o
OBJS += objs/core/board/NstBoardAveD1012.o
OBJS += objs/core/board/NstBoardAveNina.o
OBJS += objs/core/board/NstBoardAxRom.o
OBJS += objs/core/board/NstBoardBandai24c0x.o
OBJS += objs/core/board/NstBoardBandaiAerobicsStudio.o
OBJS += objs/core/board/NstBoardBandaiDatach.o
OBJS += objs/core/board/NstBoardBandaiKaraokeStudio.o
OBJS += objs/core/board/NstBoardBandaiLz93d50.o
OBJS += objs/core/board/NstBoardBandaiLz93d50ex.o
OBJS += objs/core/board/NstBoardBandaiOekaKids.o
OBJS += objs/core/board/NstBoardBenshengBs5.o
OBJS += objs/core/board/NstBoardBmc110in1.o
OBJS += objs/core/board/NstBoardBmc1200in1.o
OBJS += objs/core/board/NstBoardBmc150in1.o
OBJS += objs/core/board/NstBoardBmc15in1.o
OBJS += objs/core/board/NstBoardBmc20in1.o
OBJS += objs/core/board/NstBoardBmc21in1.o
OBJS += objs/core/board/NstBoardBmc22Games.o
OBJS += objs/core/board/NstBoardBmc31in1.o
OBJS += objs/core/board/NstBoardBmc35in1.o
OBJS += objs/core/board/NstBoardBmc36in1.o
OBJS += objs/core/board/NstBoardBmc64in1.o
OBJS += objs/core/board/NstBoardBmc72in1.o
OBJS += objs/core/board/NstBoardBmc76in1.o
OBJS += objs/core/board/NstBoardBmc800in1.o
OBJS += objs/core/board/NstBoardBmc8157.o
OBJS += objs/core/board/NstBoardBmc9999999in1.o
OBJS += objs/core/board/NstBoardBmcA65as.o
OBJS += objs/core/board/NstBoardBmcBallgames11in1.o
OBJS += objs/core/board/NstBoardBmcCh001.o
OBJS += objs/core/board/NstBoardBmcCtc65.o
OBJS += objs/core/board/NstBoardBmcFamily4646B.o
OBJS += objs/core/board/NstBoardBmcFk23c.o
OBJS += objs/core/board/NstBoardBmcGamestarA.o
OBJS += objs/core/board/NstBoardBmcGamestarB.o
OBJS += objs/core/board/NstBoardBmcGolden190in1.o
OBJS += objs/core/board/NstBoardBmcGoldenCard6in1.o
OBJS += objs/core/board/NstBoardBmcGoldenGame260in1.o
OBJS += objs/core/board/NstBoardBmcHero.o
OBJS += objs/core/board/NstBoardBmcMarioParty7in1.o
OBJS += objs/core/board/NstBoardBmcNovelDiamond.o
OBJS += objs/core/board/NstBoardBmcPowerjoy84in1.o
OBJS += objs/core/board/NstBoardBmcResetBased4in1.o
OBJS += objs/core/board/NstBoardBmcSuper22Games.o
OBJS += objs/core/board/NstBoardBmcSuper24in1.o
OBJS += objs/core/board/NstBoardBmcSuper40in1.o
OBJS += objs/core/board/NstBoardBmcSuper700in1.o
OBJS += objs/core/board/NstBoardBmcSuperBig7in1.o
OBJS += objs/core/board/NstBoardBmcSuperGun20in1.o
OBJS += objs/core/board/NstBoardBmcSuperHiK300in1.o
OBJS += objs/core/board/NstBoardBmcSuperHiK4in1.o
OBJS += objs/core/board/NstBoardBmcSuperVision16in1.o
OBJS += objs/core/board/NstBoardBmcT262.o
OBJS += objs/core/board/NstBoardBmcVrc4.o
OBJS += objs/core/board/NstBoardBmcVt5201.o
OBJS += objs/core/board/NstBoardBmcY2k64in1.o
OBJS += objs/core/board/NstBoardBtl2708.o
OBJS += objs/core/board/NstBoardBtl6035052.o
OBJS += objs/core/board/NstBoardBtlAx5705.o
OBJS += objs/core/board/NstBoardBtlDragonNinja.o
OBJS += objs/core/board/NstBoardBtlGeniusMerioBros.o
OBJS += objs/core/board/NstBoardBtlMarioBaby.o
OBJS += objs/core/board/NstBoardBtlPikachuY2k.o
OBJS += objs/core/board/NstBoardBtlShuiGuanPipe.o
OBJS += objs/core/board/NstBoardBtlSmb2a.o
OBJS += objs/core/board/NstBoardBtlSmb2b.o
OBJS += objs/core/board/NstBoardBtlSmb2c.o
OBJS += objs/core/board/NstBoardBtlSmb3.o
OBJS += objs/core/board/NstBoardBtlSuperBros11.o
OBJS += objs/core/board/NstBoardBtlT230.o
OBJS += objs/core/board/NstBoardBtlTobidaseDaisakusen.o
OBJS += objs/core/board/NstBoardBxRom.o
OBJS += objs/core/board/NstBoardCaltron.o
OBJS += objs/core/board/NstBoardCamerica.o
OBJS += objs/core/board/NstBoardCneDecathlon.o
OBJS += objs/core/board/NstBoardCnePsb.o
OBJS += objs/core/board/NstBoardCneShlz.o
OBJS += objs/core/board/NstBoardCony.o
OBJS += objs/core/board/NstBoard.o
OBJS += objs/core/board/NstBoardCxRom.o
OBJS += objs/core/board/NstBoardDiscrete.o
OBJS += objs/core/board/NstBoardDreamtech.o
OBJS += objs/core/board/NstBoardEvent.o
OBJS += objs/core/board/NstBoardFb.o
OBJS += objs/core/board/NstBoardFfe.o
OBJS += objs/core/board/NstBoardFujiya.o
OBJS += objs/core/board/NstBoardFukutake.o
OBJS += objs/core/board/NstBoardFutureMedia.o
OBJS += objs/core/board/NstBoardGouder.o
OBJS += objs/core/board/NstBoardGxRom.o
OBJS += objs/core/board/NstBoardHenggedianzi.o
OBJS += objs/core/board/NstBoardHes.o
OBJS += objs/core/board/NstBoardHosenkan.o
OBJS += objs/core/board/NstBoardIremG101.o
OBJS += objs/core/board/NstBoardIremH3001.o
OBJS += objs/core/board/NstBoardIremHolyDiver.o
OBJS += objs/core/board/NstBoardIremKaiketsu.o
OBJS += objs/core/board/NstBoardIremLrog017.o
OBJS += objs/core/board/NstBoardJalecoJf11.o
OBJS += objs/core/board/NstBoardJalecoJf13.o
OBJS += objs/core/board/NstBoardJalecoJf16.o
OBJS += objs/core/board/NstBoardJalecoJf17.o
OBJS += objs/core/board/NstBoardJalecoJf19.o
OBJS += objs/core/board/NstBoardJalecoSs88006.o
OBJS += objs/core/board/NstBoardJyCompany.o
OBJS += objs/core/board/NstBoardKaiser.o
OBJS += objs/core/board/NstBoardKasing.o
OBJS += objs/core/board/NstBoardKayH2288.o
OBJS += objs/core/board/NstBoardKayPandaPrince.o
OBJS += objs/core/board/NstBoardKonamiVrc1.o
OBJS += objs/core/board/NstBoardKonamiVrc2.o
OBJS += objs/core/board/NstBoardKonamiVrc3.o
OBJS += objs/core/board/NstBoardKonamiVrc4.o
OBJS += objs/core/board/NstBoardKonamiVrc6.o
OBJS += objs/core/board/NstBoardKonamiVrc7.o
OBJS += objs/core/board/NstBoardKonamiVsSystem.o
OBJS += objs/core/board/NstBoardMagicSeries.o
OBJS += objs/core/board/NstBoardMmc1.o
OBJS += objs/core/board/NstBoardMmc2.o
OBJS += objs/core/board/NstBoardMmc3.o
OBJS += objs/core/board/NstBoardMmc4.o
OBJS += objs/core/board/NstBoardMmc5.o
OBJS += objs/core/board/NstBoardMmc6.o
OBJS += objs/core/board/NstBoardNamcot163.o
OBJS += objs/core/board/NstBoardNamcot175.o
OBJS += objs/core/board/NstBoardNamcot34xx.o
OBJS += objs/core/board/NstBoardNanjing.o
OBJS += objs/core/board/NstBoardNihon.o
OBJS += objs/core/board/NstBoardNitra.o
OBJS += objs/core/board/NstBoardNtdec.o
OBJS += objs/core/board/NstBoardOpenCorp.o
OBJS += objs/core/board/NstBoardQj.o
OBJS += objs/core/board/NstBoardRcm.o
OBJS += objs/core/board/NstBoardRexSoftDb5z.o
OBJS += objs/core/board/NstBoardRexSoftSl1632.o
OBJS += objs/core/board/NstBoardRumbleStation.o
OBJS += objs/core/board/NstBoardSachen74x374.o
OBJS += objs/core/board/NstBoardSachenS8259.o
OBJS += objs/core/board/NstBoardSachenSa0036.o
OBJS += objs/core/board/NstBoardSachenSa0037.o
OBJS += objs/core/board/NstBoardSachenSa72007.o
OBJS += objs/core/board/NstBoardSachenSa72008.o
OBJS += objs/core/board/NstBoardSachenStreetHeroes.o
OBJS += objs/core/board/NstBoardSachenTca01.o
OBJS += objs/core/board/NstBoardSachenTcu.o
OBJS += objs/core/board/NstBoardSomeriTeamSl12.o
OBJS += objs/core/board/NstBoardSubor.o
OBJS += objs/core/board/NstBoardSunsoft1.o
OBJS += objs/core/board/NstBoardSunsoft2.o
OBJS += objs/core/board/NstBoardSunsoft3.o
OBJS += objs/core/board/NstBoardSunsoft4.o
OBJS += objs/core/board/NstBoardSunsoft5b.o
OBJS += objs/core/board/NstBoardSunsoftDcs.o
OBJS += objs/core/board/NstBoardSunsoftFme7.o
OBJS += objs/core/board/NstBoardSuperGameBoogerman.o
OBJS += objs/core/board/NstBoardSuperGameLionKing.o
OBJS += objs/core/board/NstBoardSuperGamePocahontas2.o
OBJS += objs/core/board/NstBoardTaitoTc0190fmc.o
OBJS += objs/core/board/NstBoardTaitoTc0190fmcPal16r4.o
OBJS += objs/core/board/NstBoardTaitoX1005.o
OBJS += objs/core/board/NstBoardTaitoX1017.o
OBJS += objs/core/board/NstBoardTengen.o
OBJS += objs/core/board/NstBoardTengenRambo1.o
OBJS += objs/core/board/NstBoardTxc.o
OBJS += objs/core/board/NstBoardTxcMxmdhtwo.o
OBJS += objs/core/board/NstBoardTxcPoliceman.o
OBJS += objs/core/board/NstBoardTxcTw.o
OBJS += objs/core/board/NstBoardTxRom.o
OBJS += objs/core/board/NstBoardUnlA9746.o
OBJS += objs/core/board/NstBoardUnlCc21.o
OBJS += objs/core/board/NstBoardUnlEdu2000.o
OBJS += objs/core/board/NstBoardUnlKingOfFighters96.o
OBJS += objs/core/board/NstBoardUnlKingOfFighters97.o
OBJS += objs/core/board/NstBoardUnlMortalKombat2.o
OBJS += objs/core/board/NstBoardUnlN625092.o
OBJS += objs/core/board/NstBoardUnlSuperFighter3.o
OBJS += objs/core/board/NstBoardUnlTf1201.o
OBJS += objs/core/board/NstBoardUnlWorldHero.o
OBJS += objs/core/board/NstBoardUnlXzy.o
OBJS += objs/core/board/NstBoardUxRom.o
OBJS += objs/core/board/NstBoardVsSystem.o
OBJS += objs/core/board/NstBoardWaixing.o
OBJS += objs/core/board/NstBoardWaixingFfv.o
OBJS += objs/core/board/NstBoardWaixingPs2.o
OBJS += objs/core/board/NstBoardWaixingSecurity.o
OBJS += objs/core/board/NstBoardWaixingSgz.o
OBJS += objs/core/board/NstBoardWaixingSgzlz.o
OBJS += objs/core/board/NstBoardWaixingSh2.o
OBJS += objs/core/board/NstBoardWaixingZs.o
OBJS += objs/core/board/NstBoardWhirlwind.o
OBJS += objs/core/board/NstBoardZz.o

# Input
OBJS += objs/core/input/NstInpAdapter.o

=== libretro/Makefile ===
DEBUG = 0
HAS_GCC = 1

NST_DIR = ..

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -a),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -a)),)
   platform = win
endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
EXE_EXT = .exe
   system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
   system_platform = osx
else ifneq ($(findstring MINGW,$(shell uname -a)),)
   system_platform = win
endif

LIBRETRO_DIR := libretro
TARGET_NAME := nestopia

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,-version-script=link.T -Wl,-no-undefined
else ifeq ($(platform), osx)
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
OSXVER = `sw_vers -productVersion | cut -c 4`
ifneq ($(shell sw_vers | grep -c 10.9),1)
   fpic += -mmacosx-version-min=10.5
endif
else ifeq ($(platform), ios)
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib

   CC = clang -arch armv7 -isysroot $(IOSSDK)
   CXX = clang++ -arch armv7 -isysroot $(IOSSDK)
OSXVER = `sw_vers -productVersion | cut -c 4`
ifneq ($(OSXVER),9)
   CC += -miphoneos-version-min=5.0
   CXX += -miphoneos-version-min=5.0
   PLATFORM_DEFINES += -miphoneos-version-min=5.0
endif
else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_qnx.so
   fpic := -fPIC
   SHARED := -lcpp -lm -shared -Wl,-version-script=link.T -Wl,-no-undefined
	HAS_GCC := 0

	CC = qcc -Vgcc_ntoarmv7le
	CXX = QCC -Vgcc_ntoarmv7le_cpp
	AR = QCC -Vgcc_ntoarmv7le
	PLATFORM_DEFINES := -D__BLACKBERRY_QNX__ -marm -mcpu=cortex-a9 -mfpu=neon -mfloat-abi=softfp
else ifeq ($(platform), ps3)
	HAVE_GCC_WARNINGS := 0
   TARGET := $(TARGET_NAME)_libretro_ps3.a
   CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
   CC = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-gcc.exe
   AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
   PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1
else ifeq ($(platform), sncps3)
	HAVE_GCC_WARNINGS := 0
   TARGET := $(TARGET_NAME)_libretro_ps3.a
	HAS_GCC := 0
   CC = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
   CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
   AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
   PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1
else ifeq ($(platform), psp1)
	TARGET := $(TARGET_NAME)_libretro_psp1.a
	CC = psp-gcc$(EXE_EXT)
	CXX = psp-g++$(EXE_EXT)
	AR = psp-ar$(EXE_EXT)
	ENDIANNESS_DEFINES = -DLSB_FIRST
	PLATFORM_DEFINES := -DPSP -G0
	STATIC_LINKING = 1
else ifeq ($(platform), psl1ght)
   TARGET := $(TARGET_NAME)_libretro_psl1ght.a
   CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
   CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
   AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1
else ifeq ($(platform), xenon)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CC = xenon-gcc$(EXE_EXT)
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   PLATFORM_DEFINES := -D__LIBXENON__
	STATIC_LINKING = 1
else ifeq ($(platform), ngc)
   TARGET := $(TARGET_NAME)_libretro_ngc.a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   PLATFORM_DEFINES += -DGEKKO -DHW_DOL -mrvl -mcpu=750 -meabi -mhard-float
	STATIC_LINKING = 1
else ifeq ($(platform), wii)
   TARGET := $(TARGET_NAME)_libretro_wii.a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   PLATFORM_DEFINES += -DGEKKO -DHW_RVL -mrvl -mcpu=750 -meabi -mhard-float
	STATIC_LINKING = 1
else ifneq (,$(findstring armv,$(platform)))
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,-version-script=link.T -Wl,-no-undefined
   CC = gcc
ifneq (,$(findstring cortexa8,$(platform)))
   PLATFORM_DEFINES += -marm -mcpu=cortex-a8
else ifneq (,$(findstring cortexa9,$(platform)))
   PLATFORM_DEFINES += -marm -mcpu=cortex-a9
endif
   PLATFORM_DEFINES += -marm
ifneq (,$(findstring neon,$(platform)))
   PLATFORM_DEFINES += -mfpu=neon
   HAVE_NEON = 1
endif
ifneq (,$(findstring softfloat,$(platform)))
   PLATFORM_DEFINES += -mfloat-abi=softfp
else ifneq (,$(findstring hardfloat,$(platform)))
   PLATFORM_DEFINES += -mfloat-abi=hard
endif
   PLATFORM_DEFINES += -DARM
else
   TARGET := $(TARGET_NAME)_libretro.dll
   CC = gcc
   CXX = g++
   SHARED := -shared -static-libgcc -static-libstdc++ -Wl,-no-undefined -Wl,-version-script=link.T
endif

all: $(TARGET)

ifeq ($(DEBUG), 1)
   CFLAGS += -O0 -g
   CXXFLAGS += -O0 -g
else ifeq ($(platform), ps3)
   CFLAGS += -O2
   CXXFLAGS += -O2
else
   CFLAGS += -O3
   CXXFLAGS += -O3
endif

OBJS = $(NST_DIR)/source/core/NstZlib.o

## Yes, I didn't type all this out ...
# core objs
OBJS += $(NST_DIR)/source/core/NstApu.o              $(NST_DIR)/source/core/NstFds.o            $(NST_DIR)/source/core/NstPpu.o              $(NST_DIR)/source/core/NstVector.o
OBJS += $(NST_DIR)/source/core/NstAssert.o           $(NST_DIR)/source/core/NstFile.o           $(NST_DIR)/source/core/NstProperties.o
OBJS += $(NST_DIR)/source/core/NstCartridge.o        $(NST_DIR)/source/core/NstImage.o          $(NST_DIR)/source/core/NstRam.o
OBJS += $(NST_DIR)/source/core/NstCartridgeInes.o    $(NST_DIR)/source/core/NstImageDatabase.o  $(NST_DIR)/source/core/NstSha1.o             $(NST_DIR)/source/core/NstVideoFilterNone.o
OBJS += $(NST_DIR)/source/core/NstCartridgeRomset.o  $(NST_DIR)/source/core/NstLog.o            $(NST_DIR)/source/core/NstSoundPcm.o
OBJS += $(NST_DIR)/source/core/NstCartridgeUnif.o    $(NST_DIR)/source/core/NstMachine.o        $(NST_DIR)/source/core/NstSoundPlayer.o
OBJS += $(NST_DIR)/source/core/NstCheats.o           $(NST_DIR)/source/core/NstMemory.o         $(NST_DIR)/source/core/NstSoundRenderer.o    $(NST_DIR)/source/core/NstVideoRenderer.o
OBJS += $(NST_DIR)/source/core/NstChecksum.o         $(NST_DIR)/source/core/NstNsf.o            $(NST_DIR)/source/core/NstState.o            $(NST_DIR)/source/core/NstVideoScreen.o
OBJS += $(NST_DIR)/source/core/NstChips.o            $(NST_DIR)/source/core/NstPatcher.o        $(NST_DIR)/source/core/NstStream.o           $(NST_DIR)/source/core/NstXml.o
OBJS += $(NST_DIR)/source/core/NstCore.o             $(NST_DIR)/source/core/NstPatcherIps.o     $(NST_DIR)/source/core/NstTracker.o          
OBJS += $(NST_DIR)/source/core/NstCpu.o              $(NST_DIR)/source/core/NstPatcherUps.o     $(NST_DIR)/source/core/NstTrackerMovie.o
OBJS += $(NST_DIR)/source/core/NstCrc32.o            $(NST_DIR)/source/core/NstPins.o           $(NST_DIR)/source/core/NstTrackerRewinder.o
OBJS += $(NST_DIR)/source/core/NstVideoFilterNtscCfg.o					$(NST_DIR)/source/core/NstVideoFilterNtsc.o


# core/api
OBJS += $(NST_DIR)/source/core/api/NstApiBarcodeReader.o  $(NST_DIR)/source/core/api/NstApiEmulator.o  $(NST_DIR)/source/core/api/NstApiMovie.o     $(NST_DIR)/source/core/api/NstApiTapeRecorder.o
OBJS += $(NST_DIR)/source/core/api/NstApiCartridge.o      $(NST_DIR)/source/core/api/NstApiFds.o       $(NST_DIR)/source/core/api/NstApiNsf.o       $(NST_DIR)/source/core/api/NstApiUser.o
OBJS += $(NST_DIR)/source/core/api/NstApiCheats.o         $(NST_DIR)/source/core/api/NstApiInput.o     $(NST_DIR)/source/core/api/NstApiRewinder.o  $(NST_DIR)/source/core/api/NstApiVideo.o
OBJS += $(NST_DIR)/source/core/api/NstApiDipSwitches.o    $(NST_DIR)/source/core/api/NstApiMachine.o   $(NST_DIR)/source/core/api/NstApiSound.o

# core/board
OBJS += $(NST_DIR)/source/core/board/NstBoardAe.o                    $(NST_DIR)/source/core/board/NstBoardBtlPikachuY2k.o          $(NST_DIR)/source/core/board/NstBoardNihon.o
OBJS += $(NST_DIR)/source/core/board/NstBoardAgci.o                  $(NST_DIR)/source/core/board/NstBoardBtlShuiGuanPipe.o        $(NST_DIR)/source/core/board/NstBoardNitra.o
OBJS += $(NST_DIR)/source/core/board/NstBoardAveD1012.o              $(NST_DIR)/source/core/board/NstBoardBtlSmb2a.o               $(NST_DIR)/source/core/board/NstBoardNtdec.o
OBJS += $(NST_DIR)/source/core/board/NstBoardAveNina.o               $(NST_DIR)/source/core/board/NstBoardBtlSmb2b.o               $(NST_DIR)/source/core/board/NstBoardOpenCorp.o
OBJS += $(NST_DIR)/source/core/board/NstBoardAxRom.o                 $(NST_DIR)/source/core/board/NstBoardBtlSmb2c.o               $(NST_DIR)/source/core/board/NstBoardQj.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandai24c0x.o           $(NST_DIR)/source/core/board/NstBoardBtlSmb3.o                $(NST_DIR)/source/core/board/NstBoardRcm.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiAerobicsStudio.o  $(NST_DIR)/source/core/board/NstBoardBtlSuperBros11.o         $(NST_DIR)/source/core/board/NstBoardRexSoftDb5z.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiDatach.o          $(NST_DIR)/source/core/board/NstBoardBtlT230.o                $(NST_DIR)/source/core/board/NstBoardRexSoftSl1632.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiKaraokeStudio.o   $(NST_DIR)/source/core/board/NstBoardBtlTobidaseDaisakusen.o  $(NST_DIR)/source/core/board/NstBoardRumbleStation.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiLz93d50.o         $(NST_DIR)/source/core/board/NstBoardBxRom.o                  $(NST_DIR)/source/core/board/NstBoardSachen74x374.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiLz93d50ex.o       $(NST_DIR)/source/core/board/NstBoardCaltron.o                $(NST_DIR)/source/core/board/NstBoardSachenS8259.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBandaiOekaKids.o        $(NST_DIR)/source/core/board/NstBoardCamerica.o               $(NST_DIR)/source/core/board/NstBoardSachenSa0036.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBenshengBs5.o           $(NST_DIR)/source/core/board/NstBoardCneDecathlon.o           $(NST_DIR)/source/core/board/NstBoardSachenSa0037.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc110in1.o             $(NST_DIR)/source/core/board/NstBoardCnePsb.o                 $(NST_DIR)/source/core/board/NstBoardSachenSa72007.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc1200in1.o            $(NST_DIR)/source/core/board/NstBoardCneShlz.o                $(NST_DIR)/source/core/board/NstBoardSachenSa72008.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc150in1.o             $(NST_DIR)/source/core/board/NstBoardCony.o                   $(NST_DIR)/source/core/board/NstBoardSachenStreetHeroes.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc15in1.o              $(NST_DIR)/source/core/board/NstBoard.o                       $(NST_DIR)/source/core/board/NstBoardSachenTca01.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc20in1.o              $(NST_DIR)/source/core/board/NstBoardCxRom.o                  $(NST_DIR)/source/core/board/NstBoardSachenTcu.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc21in1.o              $(NST_DIR)/source/core/board/NstBoardDiscrete.o               $(NST_DIR)/source/core/board/NstBoardSomeriTeamSl12.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc22Games.o            $(NST_DIR)/source/core/board/NstBoardDreamtech.o              $(NST_DIR)/source/core/board/NstBoardSubor.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc31in1.o              $(NST_DIR)/source/core/board/NstBoardEvent.o                  $(NST_DIR)/source/core/board/NstBoardSunsoft1.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc35in1.o              $(NST_DIR)/source/core/board/NstBoardFb.o                     $(NST_DIR)/source/core/board/NstBoardSunsoft2.o
OBJS += $(NST_DIR)/source/core/board/NstBoardBmc36in1.o              $(NST_DIR)/source/core/board/NstBoardFfe.o                    $(NST_DIR)/source/core/board/NstBoardSunsoft3.o

=== debian/changelog ===
nestopia (1.46.2-2) unstable; urgency=medium

  [ Sérgio Benjamim ]
  * New package for the libretro core.
  * Update licensing information.
  * Use the system zlib header files.
  * Correct the upstream name to "Nestopia UE" in debian/copyright.

  [ Stephen Kitt ]
  * Upstream no longer ships non-free files, drop Files-Excluded.
  * Add Sérgio to the uploaders.
  * Drop the Debian menu and XPM icon.

 -- Stephen Kitt <skitt@debian.org>  Sun, 20 Sep 2015 17:22:44 +0200

nestopia (1.46.2-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 3.9.6, no change required.
  * Add libretro licensing information.

 -- Stephen Kitt <skitt@debian.org>  Tue, 14 Oct 2014 21:58:07 +0200

nestopia (1.46.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove obsolete 7-zip licensing information.
  * Preserve build flags (to fully enable hardening).

 -- Stephen Kitt <skitt@debian.org>  Sat, 27 Sep 2014 19:25:37 +0200

nestopia (1.46-1) unstable; urgency=medium

  [ Stephen Kitt ]
  * New upstream release.
  * Use the correct homepage URL.
  * Track releases on github instead of sourceforge.
  * Update build-dependencies (SDL 2 and libao).
  * Refresh patches.

  [ Ryan Danbrook ]
  * Update description.
  * Remove unnecessary build-dependencies.

 -- Stephen Kitt <skitt@debian.org>  Wed, 03 Sep 2014 10:23:22 +0200

nestopia (1.45+dfsg-2) unstable; urgency=medium

  * Use Files-Excluded in debian/copyright to drop get-orig-source from
    debian/rules.
  * Provide an icon entry in the menu file (Closes: #726844).
  * Standards-Version 3.9.5, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 10 May 2014 14:29:01 +0200

=== debian/control ===
Source: nestopia
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>,
           Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends: debhelper (>= 9),
               libao-dev,
               libarchive-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libsdl2-dev
Standards-Version: 3.9.6
Homepage: http://0ldsk00l.ca/nestopia/
Vcs-Git: git://anonscm.debian.org/pkg-games/nestopia.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/nestopia.git;a=summary

Package: nestopia
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: nes-emulator
Description: Nintendo Entertainment System/Famicom emulator
 Nestopia is a cycle-accurate NES/Famicom emulator. It has a high
 compatibility rate and support for many peripherals and input
 devices.
 .
 Features:
    * Save states
    * Movie recording
    * Game rewinding
    * GUI or command line interface
    * Emulation of NTSC, PAL, and Dendy systems
    * Support for NES Zapper games
    * Support for Famicom Disk System games

Package: libretro-nestopia
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: retroarch
Description: libretro wrapper for Nestopia
 Nestopia is a cycle-accurate NES/Famicom emulator. It has a high
 compatibility rate and support for many peripherals and input
 devices.
 .
 This package contains a wrapper allowing the Nestopia engine to be
 used with libretro frontends such as RetroArch.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH),armhf)
	PLATFORM=platform="armv hardfloat"
endif

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --sourcedirectory=libretro -- $(PLATFORM)

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --sourcedirectory=libretro

## nestopia 1.47

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-CC = cc
-CXX = c++
+CC ?= cc
+CXX ?= c++
 CXXFLAGS ?= -O3 -g3
 CPPFLAGS += -DNST_PRAGMA_ONCE
 CFLAGS = $(shell sdl2-config --cflags)
@@ -15,19 +15,36 @@
 
 BIN = nestopia
 
-PREFIX = /usr/local
-BINDIR = $(PREFIX)/bin
-DATADIR = $(PREFIX)/share/nestopia
+PREFIX ?= /usr/local
+BINDIR ?= $(PREFIX)/bin
+DATADIR ?= $(PREFIX)/share/nestopia
 
 ifneq ($(findstring MINGW,$(UNAME)),)
-	CPPFLAGS += -DNST_NO_ZLIB
 	DEFINES = -D_MINGW
 	LDFLAGS += -mconsole
-	LIBS += -lopengl32
+	LIBS += -lepoxy -lopengl32
+else ifneq ($(findstring Darwin,$(UNAME)),)
+	DEFINES = -D_APPLE
+	DEFINES += -DDATADIR=\"$(DATADIR)\"
+	INCLUDES += -I/usr/local/include -I/usr/local/opt/libarchive/include
+	LDFLAGS = -Wl -L/usr/local/opt/libarchive/lib
+	LIBS += -larchive -lepoxy -lao
+	# GTK Stuff - Comment this section to disable GTK+
+	#CFLAGS += $(shell pkg-config --cflags gtk+-3.0)
+	#LIBS += $(shell pkg-config --libs gtk+-3.0)
+	#DEFINES += -D_GTK
+	#IOBJS += objs/unix/gtkui/gtkui.o
+	#IOBJS += objs/unix/gtkui/gtkui_archive.o
+	#IOBJS += objs/unix/gtkui/gtkui_callbacks.o
+	#IOBJS += objs/unix/gtkui/gtkui_cheats.o
+	#IOBJS += objs/unix/gtkui/gtkui_config.o
+	#IOBJS += objs/unix/gtkui/gtkui_dialogs.o
+	#OBJDIRS += objs/unix/gtkui
+	#WARNINGS += -Wno-deprecated-declarations
+	# end GTK
 else
 	DEFINES = -DDATADIR=\"$(DATADIR)\"
-	LIBS += -larchive
-	LIBS += -lGL -lGLU -lao
+	LIBS += -larchive -lepoxy -lGL -lGLU -lao
 	# GTK Stuff - Comment this section to disable GTK+
 	CFLAGS += $(shell pkg-config --cflags gtk+-3.0)
 	LIBS += $(shell pkg-config --libs gtk+-3.0)
@@ -111,6 +128,7 @@
 OBJS += objs/core/api/NstApiVideo.o
 
 # Board
+OBJS += objs/core/board/NstBoardAcclaimMcAcc.o
 OBJS += objs/core/board/NstBoardAe.o
 OBJS += objs/core/board/NstBoardAgci.o
 OBJS += objs/core/board/NstBoardAveD1012.o
@@ -288,22 +306,3 @@
 OBJS += objs/core/board/NstBoardUnlKingOfFighters97.o
 OBJS += objs/core/board/NstBoardUnlMortalKombat2.o
 OBJS += objs/core/board/NstBoardUnlN625092.o
-OBJS += objs/core/board/NstBoardUnlSuperFighter3.o
-OBJS += objs/core/board/NstBoardUnlTf1201.o
-OBJS += objs/core/board/NstBoardUnlWorldHero.o
-OBJS += objs/core/board/NstBoardUnlXzy.o
-OBJS += objs/core/board/NstBoardUxRom.o
-OBJS += objs/core/board/NstBoardVsSystem.o
-OBJS += objs/core/board/NstBoardWaixing.o
-OBJS += objs/core/board/NstBoardWaixingFfv.o
-OBJS += objs/core/board/NstBoardWaixingPs2.o
-OBJS += objs/core/board/NstBoardWaixingSecurity.o
-OBJS += objs/core/board/NstBoardWaixingSgz.o
-OBJS += objs/core/board/NstBoardWaixingSgzlz.o
-OBJS += objs/core/board/NstBoardWaixingSh2.o
-OBJS += objs/core/board/NstBoardWaixingZs.o
-OBJS += objs/core/board/NstBoardWhirlwind.o
-OBJS += objs/core/board/NstBoardZz.o
-
-# Input
-OBJS += objs/core/input/NstInpAdapter.o

=== libretro/Makefile ===
DEBUG = 0
HAS_GCC = 1

ifeq ($(platform),)
	platform = unix
	ifeq ($(shell uname -a),)
		platform = win
	else ifneq ($(findstring MINGW,$(shell uname -a)),)
		platform = win
	else ifneq ($(findstring Darwin,$(shell uname -a)),)
		platform = osx
	else ifneq ($(findstring win,$(shell uname -a)),)
		platform = win
	endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -a),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -a)),)
	system_platform = osx
else ifneq ($(findstring MINGW,$(shell uname -a)),)
	system_platform = win
endif

LIBRETRO_DIR := libretro
TARGET_NAME := nestopia

# Unix
ifeq ($(platform), unix)
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,-version-script=link.T -Wl,-no-undefined

# OS X
else ifeq ($(platform), osx)
	TARGET := $(TARGET_NAME)_libretro.dylib
	fpic := -fPIC
	SHARED := -dynamiclib
	OSXVER = `sw_vers -productVersion | cut -d. -f 2`
	OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
	ifndef ($(NOUNIVERSAL))
		CFLAGS  += $(ARCHFLAGS)
		CXXFLAGS  += $(ARCHFLAGS)
		LDFLAGS += $(ARCHFLAGS)
	endif

# iOS
else ifneq (,$(findstring ios,$(platform)))

	TARGET := $(TARGET_NAME)_libretro_ios.dylib
	fpic := -fPIC
	SHARED := -dynamiclib
	ifeq ($(IOSSDK),)
		IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
	endif
	CC = cc -arch armv7 -isysroot $(IOSSDK)
	CXX = c++ -arch armv7 -isysroot $(IOSSDK)
ifeq ($(platform),ios9)
	CC               += -miphoneos-version-min=8.0
	CXX              += -miphoneos-version-min=8.0
	PLATFORM_DEFINES += -miphoneos-version-min=8.0
else
	CC               += -miphoneos-version-min=5.0
	CXX              += -miphoneos-version-min=5.0
	PLATFORM_DEFINES += -miphoneos-version-min=5.0
endif

# Theos
else ifeq ($(platform), theos_ios)
	HAS_GCC := 0
	DEPLOYMENT_IOSVERSION = 5.0
	TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
	ARCHS = armv7 armv7s
	TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
	THEOS_BUILD_DIR := objs
	include $(THEOS)/makefiles/common.mk
	LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
	TARGET := $(TARGET_NAME)_libretro_qnx.so
	fpic := -fPIC
	SHARED := -lcpp -lm -shared -Wl,-version-script=link.T -Wl,-no-undefined
	HAS_GCC := 0
	CC = qcc -Vgcc_ntoarmv7le
	CXX = QCC -Vgcc_ntoarmv7le_cpp
	AR = QCC -Vgcc_ntoarmv7le
	PLATFORM_DEFINES := -D__BLACKBERRY_QNX__ -marm -mcpu=cortex-a9 -mfpu=neon -mfloat-abi=softfp

# PS3
else ifeq ($(platform), ps3)
	HAVE_GCC_WARNINGS := 0
	TARGET := $(TARGET_NAME)_libretro_ps3.a
	CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
	CC = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-gcc.exe
	AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
	PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1

# sncps3
else ifeq ($(platform), sncps3)
	HAVE_GCC_WARNINGS := 0
	TARGET := $(TARGET_NAME)_libretro_ps3.a
	HAS_GCC := 0
	CC = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
	CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
	AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
	PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1

# PSP
else ifeq ($(platform), psp1)
	TARGET := $(TARGET_NAME)_libretro_psp1.a
	CC = psp-gcc$(EXE_EXT)
	CXX = psp-g++$(EXE_EXT)
	AR = psp-ar$(EXE_EXT)
	PLATFORM_DEFINES := -DPSP -G0
	STATIC_LINKING = 1

# Vita
else ifeq ($(platform), vita)
	TARGET := $(TARGET_NAME)_libretro_vita.a
	CC = arm-vita-eabi-gcc$(EXE_EXT)
	AR = arm-vita-eabi-ar$(EXE_EXT)
	PLATFORM_DEFINES := -DVITA
	STATIC_LINKING = 1

# CTR(3DS)
else ifeq ($(platform), ctr)
	TARGET := $(TARGET_NAME)_libretro_ctr.a
	CC = $(DEVKITARM)/bin/arm-none-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITARM)/bin/arm-none-eabi-g++$(EXE_EXT)
	AR = $(DEVKITARM)/bin/arm-none-eabi-ar$(EXE_EXT)
	PLATFORM_DEFINES := -DARM11 -D_3DS
	PLATFORM_DEFINES += -march=armv6k -mtune=mpcore -mfloat-abi=hard
	PLATFORM_DEFINES += -mword-relocations
	PLATFORM_DEFINES += -fomit-frame-pointer -fstrict-aliasing -ffast-math
	CXXFLAGS += -fno-rtti
	STATIC_LINKING = 1

# Lightweight PS3 Homebrew SDK
else ifeq ($(platform), psl1ght)
	TARGET := $(TARGET_NAME)_libretro_psl1ght.a
	CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
	CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
	AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
	PLATFORM_DEFINES := -D__CELLOS_LV2__
	STATIC_LINKING = 1

# Xbox 360
else ifeq ($(platform), xenon)
	TARGET := $(TARGET_NAME)_libretro_xenon360.a
	CC = xenon-gcc$(EXE_EXT)
	CXX = xenon-g++$(EXE_EXT)
	AR = xenon-ar$(EXE_EXT)
	PLATFORM_DEFINES := -D__LIBXENON__
	STATIC_LINKING = 1

# Nintendo Game Cube
else ifeq ($(platform), ngc)
	TARGET := $(TARGET_NAME)_libretro_ngc.a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	PLATFORM_DEFINES += -DGEKKO -DHW_DOL -mrvl -mcpu=750 -meabi -mhard-float
	STATIC_LINKING = 1

# Nintendo Wii
else ifeq ($(platform), wii)
	TARGET := $(TARGET_NAME)_libretro_wii.a
	CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
	CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
	AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
	PLATFORM_DEFINES += -DGEKKO -DHW_RVL -mrvl -mcpu=750 -meabi -mhard-float
	STATIC_LINKING = 1

# ARM
else ifneq (,$(findstring armv,$(platform)))
	TARGET := $(TARGET_NAME)_libretro.so
	fpic := -fPIC
	SHARED := -shared -Wl,-version-script=link.T -Wl,-no-undefined
	ifneq (,$(findstring cortexa5,$(platform)))
		PLATFORM_DEFINES += -marm -mcpu=cortex-a5
	else ifneq (,$(findstring cortexa8,$(platform)))
		PLATFORM_DEFINES += -marm -mcpu=cortex-a8
	else ifneq (,$(findstring cortexa9,$(platform)))
		PLATFORM_DEFINES += -marm -mcpu=cortex-a9
	else ifneq (,$(findstring cortexa15a7,$(platform)))
		PLATFORM_DEFINES += -marm -mcpu=cortex-a15.cortex-a7
	else
		PLATFORM_DEFINES += -marm
	endif
	ifneq (,$(findstring softfloat,$(platform)))
		PLATFORM_DEFINES += -mfloat-abi=softfp
	else ifneq (,$(findstring hardfloat,$(platform)))
		PLATFORM_DEFINES += -mfloat-abi=hard
	endif
	PLATFORM_DEFINES += -DARM

else ifeq ($(platform),emscripten)
	TARGET := $(TARGET_NAME)_libretro.bc

# Windows
else
	TARGET := $(TARGET_NAME)_libretro.dll
	CC = gcc
	CXX = g++
	SHARED := -shared -static-libgcc -static-libstdc++ -Wl,-no-undefined -Wl,-version-script=link.T

endif

ifeq ($(DEBUG), 1)
	CFLAGS += -O0 -g
	CXXFLAGS += -O0 -g
else ifeq ($(platform), ps3)
	CFLAGS += -O2
	CXXFLAGS += -O2
else
	CFLAGS += -O3
	CXXFLAGS += -O3
endif

CORE_DIR = ..

include Makefile.common

OBJS := $(SOURCES_CXX:.cpp=.o)

ifeq ($(HAS_GCC), 1)
GCC_FLAGS := -Wno-deprecated -Wno-write-strings
C_VER = -std=gnu99
else
endif

DEFINES := -D__LIBRETRO__ $(PLATFORM_DEFINES) $(GCC_FLAGS) $(GCC_WARNINGS) -DNST_NO_ZLIB $(INCFLAGS)

CFLAGS += $(fpic) $(DEFINES) $(C_VER)
CXXFLAGS += $(fpic) $(DEFINES) -fno-rtti

INCDIRS := -I$(CORE_DIR) -I$(CORE_DIR)/source

ifeq ($(platform), theos_ios)
COMMON_FLAGS := -DIOS $(DEFINES) $(INCFLAGS) $(INCDIRS) -I$(THEOS_INCLUDE_PATH) -Wno-error
$(LIBRARY_NAME)_CFLAGS += $(CFLAGS) $(COMMON_FLAGS)
$(LIBRARY_NAME)_CXXFLAGS += $(CXXFLAGS) $(COMMON_FLAGS)
${LIBRARY_NAME}_FILES = $(SOURCES_CXX) $(SOURCES_C)
include $(THEOS_MAKE_PATH)/library.mk
else
all: $(TARGET)

$(TARGET): $(OBJS)
ifeq ($(STATIC_LINKING), 1)
	$(AR) rcs $@ $(OBJS)
else
	$(CXX) -o $@ $(SHARED) $(OBJS) $(LDFLAGS) $(LIBS)
endif

%.o: %.cpp
	$(CXX) -c -o $@ $< $(CXXFLAGS) $(INCDIRS)

%.o: %.c
	$(CC) -c -o $@ $< $(CFLAGS) $(INCDIRS)

clean-objs:
	rm -f $(OBJS)

clean:
	rm -f $(OBJS)
	rm -f $(TARGET)

.PHONY: clean clean-objs
endif

=== debian/changelog ===
nestopia (1.47-2ubuntu4) bionic; urgency=medium

  * libretro-nestopia: Install nestopia.libretro so that GNOME
    Games recognizes this package (LP: #1812467)

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 18 Jan 2019 23:43:17 -0500

nestopia (1.47-2ubuntu3) artful; urgency=medium

  * Update appstream metadata
    - libretro-nestopia: Extend retroarch too
    - nestopia: Fix typo
  * debian/control:
    - Drop alternate Depends on gnome-games-app. gnome-games-app
      will Provide libretro-frontend instead.

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 23 Apr 2017 18:54:06 -0400

nestopia (1.47-2ubuntu2) zesty; urgency=medium

  * Use correct bullets in appstream metadata

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 07 Apr 2017 22:41:45 -0400

nestopia (1.47-2ubuntu1) zesty; urgency=medium

  * Add appstream and .libretro metadata for better integration
    with gnome-games-app and gnome-software
  * Allow gnome-games-app to be an alternate depends for libretro-nestopia
  * Use dh-exec instead of manual .sh script for install file

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 05 Apr 2017 12:08:18 -0400

nestopia (1.47-2) unstable; urgency=medium

  * Switch to https: VCS URIs (see #810378).
  * Now that retroarch is in the archive, depend on it, with the
    libretro-frontend alternative (thanks to Sérgio Benjamim!).
  * Clean up debian/control using cme.
  * Standards-Version 3.9.8, no change required.
  * Enable -fpermissive to build with GCC 6 (Closes: #811688).
  * Enable all hardening options except PIE (which breaks libretro).

 -- Stephen Kitt <skitt@debian.org>  Wed, 29 Jun 2016 20:52:20 +0200

nestopia (1.47-1) unstable; urgency=medium

  [ Stephen Kitt ]
  * New upstream release.
  * Stop installing readme.html in libretro-nestopia, it doesn't seem
    relevant.

  [ Sérgio Benjamim ]
  * Correct the version for libretro.

 -- Stephen Kitt <skitt@debian.org>  Tue, 12 Jan 2016 20:39:07 +0100

=== debian/control ===
Source: nestopia
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>,
           Sérgio Benjamim <sergio_br2@yahoo.com.br>
Section: games
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-exec,
               libao-dev,
               libarchive-dev,
               libglew-dev,
               libgtk-3-dev,
               libsdl2-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/nestopia.git
Vcs-Git: https://anonscm.debian.org/git/pkg-games/nestopia.git
Homepage: http://0ldsk00l.ca/nestopia/

Package: nestopia
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: nes-emulator
Description: Nintendo Entertainment System/Famicom emulator
 Nestopia is a cycle-accurate NES/Famicom emulator. It has a high
 compatibility rate and support for many peripherals and input
 devices.
 .
 Features:
    * Save states
    * Movie recording
    * Game rewinding
    * GUI or command line interface
    * Emulation of NTSC, PAL, and Dendy systems
    * Support for NES Zapper games
    * Support for Famicom Disk System games

Package: libretro-nestopia
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend,
         ${misc:Depends},
         ${shlibs:Depends}
Description: libretro wrapper for Nestopia
 Nestopia is a cycle-accurate NES/Famicom emulator. It has a high
 compatibility rate and support for many peripherals and input
 devices.
 .
 This package contains a wrapper allowing the Nestopia engine to be
 used with libretro frontends such as RetroArch.

=== debian/watch ===
version=3

opts=dversionmangle=s/.dfsg$// \
  https://github.com/rdanbrook/nestopia/releases .*/(.*)\.tar\.gz
